'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _mudash = require('mudash');

var _mudash2 = _interopRequireDefault(_mudash);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactNative = require('react-native');

var _reactRedux = require('react-redux');

var _moltres = require('moltres');

var _EngineShape = require('./EngineShape');

var _EngineShape2 = _interopRequireDefault(_EngineShape);

var _inject = require('../inject');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Moltres = function (_Component) {
  _inherits(Moltres, _Component);

  function Moltres(props, context) {
    _classCallCheck(this, Moltres);

    var _this = _possibleConstructorReturn(this, (Moltres.__proto__ || Object.getPrototypeOf(Moltres)).call(this, props, context));

    _this.handleBlueprintChange = _this.handleBlueprintChange.bind(_this);
    _this.propChangeHandlers = {
      blueprint: _this.handleBlueprintChange
    };
    return _this;
  }

  _createClass(Moltres, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      _inject.MoltresReactInjection.inject(this.props.engine);
      (0, _moltres.handleChanges)(this.propChangeHandlers, this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      (0, _moltres.handleChanges)(this.propChangeHandlers, nextProps, this.props);
    }
  }, {
    key: 'getChildContext',
    value: function getChildContext() {
      return { engine: this.props.engine };
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _reactRedux.Provider,
        { store: this.props.engine.getStore() },
        this.renderDrivers() || _react2.default.createElement(_reactNative.View, null)
      );
    }
  }, {
    key: 'renderDrivers',
    value: function renderDrivers() {
      var drivers = this.props.engine.getDriversInDependencyOrder();
      return _mudash2.default.reduceRight(drivers, function (child, driver) {
        if (_mudash2.default.isFunction(_mudash2.default.get(driver, 'renderDriver'))) {
          return driver.renderDriver(child);
        }
        return child;
      }, null);
    }
  }, {
    key: 'handleBlueprintChange',
    value: function handleBlueprintChange(blueprint) {
      this.props.engine.updateBlueprint(blueprint);
    }
  }]);

  return Moltres;
}(_react.Component);

Moltres.propTypes = {
  blueprint: _react.PropTypes.object,
  engine: _EngineShape2.default.isRequired
};
Moltres.defaultProps = {
  blueprint: {}
};
Moltres.childContextTypes = {
  engine: _EngineShape2.default.isRequired
};
exports.default = Moltres;
//# sourceMappingURL=Moltres.js.map
